unit AFDBEdit;

interface


uses
{$IFDEF WIN32} 
  Windows,
{$ELSE}
  WinTypes,
  WinProcs,
{$ENDIF} 
  Classes,
  Controls,
  SysUtils,
  StdCtrls,
  Messages,
  Graphics,
  DBCtrls,
  db;
type
TAFDBEdit = class(TDBEdit)
  
  private
	FFocusedColor:	TColor;
	FFocusedFontColor:		TColor;
	VecchioColor: TColor;
	VecchioFontColor: TColor;
	{ Private declarations }
	procedure CMEnter(var Message: TCMGotFocus); message CM_ENTER;
	procedure CMExit(var Message: TWMNoParams); message CM_EXIT;
	procedure SetFocusedColor(Valore: TColor);
	procedure SetFocusedFontColor(Valore: TColor);
  protected
	 { Protected declarations }
  public
	 { Public declarations }
	 
    procedure KeyPress(var Key: Char); override;
	 constructor Create(AOwner: TComponent); override;
  published                       
	 { Published declarations }
	 property FocusedColor: TColor
											read FFocusedColor
											write SetFocusedColor;
	 property FocusedFontColor: TColor
											read FFocusedFontColor
											write SetFocusedFontColor;
  end;
procedure Register;
implementation
procedure Register;
begin
  RegisterComponents('AF', [TAFDBEdit]);
end;
constructor TAFDBEdit.Create(AOwner: TComponent);
begin
	inherited;
	FFocusedColor := clAqua;
	Color := clSilver;
	FFocusedFontColor := clBlack;
end;

procedure TAFDBEdit.SetFocusedColor(Valore: TColor);
begin
	
	if FFocusedColor <> Valore then
		FFocusedColor := Valore;
end;

procedure TAFDBEdit.SetFocusedFontColor(Valore: TColor);
begin
	
	if FFocusedFontColor <> Valore then
		FFocusedFontColor := Valore;
end;                                

procedure TAFDBEdit.CMEnter(var Message: TCMGotFocus);
begin
	VecchioColor := Color;
	VecchioFontColor := Font.Color;
	Color := FFocusedColor;
	Font.Color := FFocusedFontColor;
	inherited;
end;

procedure TAFDBEdit.CMExit(var Message: TWMNoParams);
begin
	Color := VecchioColor;
	Font.Color := VecchioFontColor;
	inherited;
end;
procedure TAFDBEdit.KeyPress(var Key: Char);
var
f: TField;
begin
F := DataSource.DataSet.FindField(DataField);
If F.DataType = ftFloat then
	begin
	if (Key = ',') or (Key = '.') then
				if (Pos(',',Text) > 0) or (Pos('.',Text) > 0) then 
					Key := #15
				else 
					Key := DecimalSeparator;
	end;
	if Key <> #0 then inherited KeyPress(Key); 
end;
end.
 